unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mcombbox, MultLang, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    MultLang1: TMultLang;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Label3: TLabel;
    Memo3: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Copy1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Test11: TMenuItem;
    Test21: TMenuItem;
    Test31: TMenuItem;
    Label4: TLabel;
    Label5: TLabel;
    Memo4: TMemo;
    Language1: TMenuItem;
    N1: TMenuItem;
    Label6: TLabel;
    procedure MultLang1Translated(Sender: TObject; LanguageName: String;
      Successful: Boolean);
    procedure Memo1Enter(Sender: TObject);
    procedure Memo2Enter(Sender: TObject);
    procedure Memo3Enter(Sender: TObject);
    procedure Memo4Enter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure WMDrawItem(var Msg: TWMDrawItem); message WM_DRAWITEM;
    procedure WMMeasureItem(var Msg: TWMMeasureItem); message WM_MEASUREITEM;
    function GetTextOfCommand(Cmd:Word):string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMMeasureItem(var Msg: TWMMeasureItem);
var MainCnt:integer;
begin
  inherited;
  if MainMenu1=nil then Exit;

  {Measure the menu item size using the Current Font and Canvas of the Form}
  with Msg.MeasureItemStruct^ do
    begin
    ItemWidth:=0;
    for MainCnt:=0 to MainMenu1.Items.Count-1 do
      if (ItemID=MainMenu1.Items[MainCnt].Command) then
        begin
        ItemWidth:=Canvas.TextWidth(GetTextOfCommand(itemID)) + 2;
        Break;
        end;
    if (ItemWidth=0) then
      ItemWidth:=Canvas.TextWidth(GetTextOfCommand(itemID)) + LoWord(GetMenuCheckMarkDimensions) + 10;
    ItemHeight:=(Canvas.TextHeight(GetTextOfCommand(itemID)) or HiWord(GetMenuCheckMarkDimensions)) + 3;
    end;
end;

procedure TForm1.WMDrawItem(var Msg: TWMDrawItem);
var s:string; c:LongInt;
begin
  inherited;
  with Msg.DrawItemStruct^ do
    begin
    Inc(rcItem.Top);
    s:=GetTextOfCommand(itemID);
    SelectObject(hDC, Label6.Font.Handle);
    if (ItemState and ODS_SELECTED) <> 0 then
      begin {Item is selected}
      IdentToColor('clHighLightText', c);
      SetTextColor(hDC, ColorToRGB(c));
      IdentToColor('clHighLight', c);
      SetBkColor(hDC, ColorToRGB(c));
      end;
    ExtTextOut(hDC, 0, 0, ETO_OPAQUE or ETO_CLIPPED, @rcItem, nil, 0, nil);
    if (ItemState and ODS_CHECKED) <> 0 then
      ExtTextOut(hDC, rcItem.Left+2, rcItem.Top, ETO_CLIPPED, @rcItem, 'O', 1, nil);
    if (hWndItem<>MainMenu1.Handle) then Inc(rcItem.Left, LoWord(GetMenuCheckMarkDimensions))
    else Inc(rcItem.Left, 6);
    DrawText(hDC, PChar(s), Length(s), rcItem, 0);
    end;
end;

function TForm1.GetTextOfCommand(Cmd:Word):string;
var i, i2:integer;
begin
  {Get the text of the menu item specified by the Command parameter}
  for i:=0 to MainMenu1.Items.Count-1 do
    with MainMenu1.Items[i] do
      if (Cmd=Command) then Result:=Caption
      else for i2:=0 to Count-1 do
        if (Cmd=Items[i2].Command) then Result:=Items[i2].Caption;
end;

procedure TForm1.MultLang1Translated(Sender: TObject; LanguageName: String;
  Successful: Boolean);
var MainMnuCnt, ClientMnuCnt:integer; mInfo:TMenuItemInfo; LOGFONT:TLOGFONT;
begin
  mInfo.fMASK:=MIIM_TYPE;
  mInfo.fType:=MFT_OWNERDRAW;
  for MainMnuCnt:=0 to MainMenu1.Items.Count-1 do
    with MainMenu1.Items[MainMnuCnt] do
      begin
      SetMenuItemInfo(MainMenu1.Handle, Command, False, mInfo);
      for ClientMnuCnt:=0 to Count-1 do
        if (Items[ClientMnuCnt].Caption<>'-') then
          SetMenuItemInfo(Handle, Items[ClientMnuCnt].Command, False, mInfo);
      end;
  GetObject(Label6.Font.Handle, SizeOf(LOGFONT), @LOGFONT);
  if (LanguageName='English') then LOGFONT.lfCharSet:=ANSI_CHARSET
  else if (LanguageName='Polish') then LOGFONT.lfCharSet:=BALTIC_CHARSET
  else if (LanguageName='Greek') then LOGFONT.lfCharSet:=GREEK_CHARSET
  else if (LanguageName='RUSSIAN') then LOGFONT.lfCharSet:=RUSSIAN_CHARSET;
  Label6.Font.Handle:=CreateFontIndirect(LOGFONT);
  DrawMenuBar(MainMenu1.WindowHandle);
end;

procedure TForm1.Memo1Enter(Sender: TObject);
begin
  MultLang1.Translate('English', False);
end;

procedure TForm1.Memo2Enter(Sender: TObject);
begin
  MultLang1.Translate('Polish', False);
end;

procedure TForm1.Memo3Enter(Sender: TObject);
begin
  MultLang1.Translate('Greek', False);
end;

procedure TForm1.Memo4Enter(Sender: TObject);
begin
  MultLang1.Translate('Russian', False);
end;

procedure TForm1.FormCreate(Sender: TObject);
var LOGFONT:TLOGFONT;
begin
  GetObject(Memo1.Font.Handle, SizeOf(LOGFONT), @LOGFONT);
  LOGFONT.lfCharSet:=ANSI_CHARSET;
  Form1.Memo1.Font.Handle:=CreateFontIndirect(LOGFONT);
  GetObject(Memo2.Font.Handle, SizeOf(LOGFONT), @LOGFONT);
  LOGFONT.lfCharSet:=BALTIC_CHARSET;
  Form1.Memo2.Font.Handle:=CreateFontIndirect(LOGFONT);
  GetObject(Memo3.Font.Handle, SizeOf(LOGFONT), @LOGFONT);
  LOGFONT.lfCharSet:=GREEK_CHARSET;
  Form1.Memo3.Font.Handle:=CreateFontIndirect(LOGFONT);
  GetObject(Memo4.Font.Handle, SizeOf(LOGFONT), @LOGFONT);
  LOGFONT.lfCharSet:=RUSSIAN_CHARSET;
  Form1.Memo4.Font.Handle:=CreateFontIndirect(LOGFONT);
end;

end.
